<template>
  <div>
    <h3>
      <template v-if="posicionPrevia">
        cambiar posición
      </template>
      <template v-else>
        tomar posición
      </template>
    </h3>
    <custom-form
      :fields="fields"
      :handleSubmit="handleSubmit"
      :parseError="parseError"
    />
  </div>
</template>

<script>
import CustomForm from '@/components/Form'

export default {
  name: 'TomarPosicionForm',
  props: ['consensoId', 'posicionPrevia', 'barcaId'],
  components: { CustomForm },
  computed: {
    fields() {
      return [
        {
          name: 'estado',
          required: true,
          type: 'select',
          value: this.posicionPrevia ? this.posicionPrevia.estado : '',
          options: [
            { value: '', content: 'Elegí una posición', disabled: true },
            { value: 'compromiso', content: 'Me comprometo' },
            { value: 'a_favor', content: 'A favor' },
            { value: 'en_contra', content: 'En contra' },
            { value: 'bloqueo', content: 'BLOQUEO!' },
            { value: 'indiferente', content: 'Indiferente' },
          ],
        },
        {
          name: 'comentario',
          type: 'textarea',
          placeholder: 'descripción (opcional)',
          value: this.posicionPrevia && this.posicionPrevia.comentario,
        },
        {
          type: 'submit',
          content: this.posicionPrevia ? 'cambiar posición' : 'tomar posición',
        },
      ]
    },
  },
  methods: {
    handleSubmit(posicion) {
      const { consensoId, barcaId } = this
      return this.$store.dispatch('crearPosicion', {
        barcaId,
        consensoId,
        posicion,
      })
    },
    parseError: error => error,
  },
}
</script>

<style lang="sass" scoped>
h3
  margin: 0.5em auto
</style>
